unit Main;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, LResources;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


function Munge(n: Int64): Int64;
begin
  Result := 0;
  while n <> 0 do
  begin
    Result := 2 * Result + (n mod 2);
    n := n div 2
  end;
end; { Munge }

procedure TForm1.Button1Click(Sender: TObject);
var
  v: Int64; { to capture result value of Val }
  c: Integer; { to capture return code of Val }
  s: String; { textual representation of result }
begin
  Val(Edit1.Text, v, c);
  if (c <> 0) or (v < 0) then
    s := 'Enter a natural number'
  else { (c = 0) and (v > 0) }
    if v = 300 then
      s := 'Do it yourself!'
    else
      Str(Munge(v): 1, s);
  Edit2.Text := s;
  Edit1.SetFocus;
  Edit1.SelectAll
end;

initialization
  {$i Main.lrs}

end.
